#
# FactoryRegistry
#
# Registry for object factories.
#
# Copyright (c) 2001-2003 by Philipp "philiKON" von Weitershausen
#
# This software is distributed under the terms of the Mozilla Public License
# (MPL)
#

"""
$Id: FactoryRegistry.py,v 1.2 2003/03/17 13:49:49 philipp Exp $
"""

from interfaces.FactoryRegistry import IFactoryRegistry

class FactoryRegistry:
    """
    Registry for object factories
    """

    __implements__ = IFactoryRegistry

    def __init__(self):
        self._reg = {}

    def register(self, meta_type, obj):
        self._reg[meta_type] = obj

    def getFactory(self, meta_type):
        return self._reg.get(meta_type, None)

    def getSupportedMetaTypes(self):
        return tuple(self._reg.keys())

FactoryRegistry = FactoryRegistry()

# load default generators
# they register themselves
import ObjectFactories
